<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\LaporanpelumasService;
use App\Http\Services\ItemService;
use App\Http\Services\VoyagesService;
use App\Http\Services\UsersService;
use PDF;


class PelumasController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $voyage;
    private $users;
    private $activityLog;


    public function __construct()
    {
        parent::__construct();
        $this->baseService = new LaporanpelumasService();
        $this->users = new UsersService();
        $this->item = new ItemService();
        $this->voyage = new VoyagesService();
    }

    public function create(Request $request)
    {
        $this->data["voyages"] = $this->voyage->getNonVoyage();
        $this->data["latestDataReport"] = $this->baseService->getLatestDataReport();
        return view("modules.pelumas.pelumasvoyage_dock", $this->data);
    }

    public function store(Request $request)
    {
        $input = $request->all();
        $voyage = $this->voyage->show($input["voyageKode"], "voyageKode");
        $input["voyageName"] = $voyage->voyageName;
        $ID = $this->baseService->store($input);
        if ($ID) {
            return redirect()->to("administrator/pelumasvoyage/show/" . $ID)->with("successMessages", "Data sudah berhasil disimpan");
        } else {
            return redirect()->back()->with("errMessage", "Something wrong, please try again.");
        }
    }

    public function pagingBulan(Request $request)
    {
        $this->data["laporans"] = $this->baseService->pagingBulan($request);
        return view("modules.pelumas.pelumasbulan_index", $this->data);
    }

    public function pagingVoyage(Request $request)
    {
        $this->data["laporans"] = $this->baseService->pagingVoyage($request);
        return view("modules.pelumas.pelumasvoyage_index", $this->data);
    }

    public function showPelumasVoyageReport(Request $request, $id)
    {
        $this->data["laporan"] = $this->baseService->show($request, $id);
        if ($this->data["laporan"]) {
            if ($this->data["laporan"]->is_locked == "N") {
                $auth = json_decode($request->session()->get('auth'));
                $this->data["portBunker"] = explode(";", $auth->sysParams->PORTBUNKER);
                return view("modules.pelumas.pelumasvoyage_create", $this->data);
            } else {
                return view("modules.pelumas.pelumasvoyage_show", $this->data);
            }
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    public function showPelumasBulanReport(Request $request, $id)
    {
        $this->data["laporan"] = $this->baseService->show($request, $id);
        if ($this->data["laporan"]) {
            if ($this->data["laporan"]->is_locked == "N") {
                $auth = json_decode($request->session()->get('auth'));
                $this->data["portBunker"] = explode(";", $auth->sysParams->PORTBUNKER);
                return view("modules.pelumas.pelumasbulan_create", $this->data);
            } else {
                return view("modules.pelumas.pelumasbulan_show", $this->data);
            }
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    public function update(Request $request, $ID)
    {
        $this->data["laporan"] = $this->baseService->show($request, $ID);
        if ($this->data["laporan"]) {
            if ($this->data["laporan"]->is_locked == "N") {
                $input = $request->all();
                $this->baseService->update($ID, $input);
                if ($this->data["laporan"]->tipe == "VOYAGE") {
                    return redirect()->to("administrator/pelumasvoyage/show/" . $ID)->with("successMessages", "Data sudah berhasil disimpan");
                } else {
                    return redirect()->to("administrator/pelumasbulan/show/" . $ID)->with("successMessages", "Data sudah berhasil disimpan");
                }
            } else {
                return redirect()->back()->with("errMessage", "The report has been locked.");
            }
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    public function repopulateData(Request $request)
    {
        $input = $request->all();
        if (isset($input["laporanID"])) {
            $this->data["laporan"] = $this->baseService->show($request, $input["laporanID"]);
            if ($this->data["laporan"]) {
                if ($this->data["laporan"]->is_locked == "N") {
                    $this->baseService->repopulateData($this->data["laporan"]);
                    echo json_encode(["status" => 1, "message" => "Repopulate data berhasil"]);
                } else {
                    echo json_encode(["message" => "Report ID is already locked"]);
                }
            } else {
                echo json_encode(["message" => "Report ID is not found"]);
            }
        } else {
            echo json_encode(["message" => "Report ID is not set"]);
        }
    }

    public function kunciLaporan(Request $request)
    {
        $input = $request->all();
        if (isset($input["laporanID"])) {
            $this->data["laporan"] = $this->baseService->show($request, $input["laporanID"]); //get certain data from service
            if ($this->data["laporan"]) {
                if ($this->data["laporan"]->is_locked == "N") {
                    $is_locked = "Y";
                    $this->baseService->isLocked($this->data["laporan"]->id, $is_locked);
                    echo json_encode(["status" => 1, "message" => "Data Report is locked"]);
                } else {
                    echo json_encode(["status" => 1, "message" => "Data Report is already locked"]);
                }
            } else {
                echo json_encode(["message" => "Report ID is not found"]);
            }
        } else {
            echo json_encode(["message" => "Report ID is not set"]);
        }
    }
    public function repopulateDataMonth(Request $request)
    {
        $input = $request->all();
        if (isset($input["laporanID"])) {
            $this->data["laporan"] = $this->baseService->show($request, $input["laporanID"]);
            if ($this->data["laporan"]) {
                if ($this->data["laporan"]->is_locked == "N") {
                    $this->baseService->repopulateDataMonth($this->data["laporan"]);
                    echo json_encode(["status" => 1, "message" => "Repopulate data berhasil"]);
                } else {
                    echo json_encode(["message" => "Report ID is already locked"]);
                }
            } else {
                echo json_encode(["message" => "Report ID is not found"]);
            }
        } else {
            echo json_encode(["message" => "Report ID is not set"]);
        }
    }

    public function generatePDFVoyage(Request $request)
    {
        $input = $request->all();
        $auth = json_decode($request->session()->get('auth'));

        $this->data["kapal"] = $this->data["namaKapal"] = $auth->namaKapal;
        $this->data["noLaporan"] = $input["noLaporan"];
        $this->data["tipe"] = "VOYAGE";
        $this->data["textType"] = "VOYAGE";
        $tahunReport = $input["tahunReport"];

        PDF::SetTitle('LAPORAN PENERIMAAN DAN PEMAKAIAN MINYAK PELUMAS PER VOYAGE');
        PDF::AddPage();
        PDF::setPageOrientation("L");

        PDF::setFooterCallback(function ($pdf) {
            $pdf->SetY(-15);
            $pdf->SetFont('helvetica', 'I', 8);
            $pdf->Cell(0, 10, 'Halaman ' . $pdf->getAliasNumPage() . '/' . $pdf->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
        });


        $this->data["i"] = 1;
        $this->data["data"] = $this->baseService->getDataReport($tahunReport, $this->data["tipe"]);

        $this->data["approver"] = $this->users->getNahkodaProfile($auth->kapalId, $auth->sysParams->JABATANNAHKODA);
        $this->data["requester"] = $this->users->getNahkodaProfile($auth->kapalId, $auth->sysParams->JABATANKKM);
        // return view("modules.pelumas.pelumasbulan_pdf", $this->data);
        $view = \View::make("modules.pelumas.pelumasbulan_pdf", $this->data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('laporan-pelumas-voyage.pdf');
    }

    public function generatePDFBulan(Request $request)
    {
        $input = $request->all();
        $auth = json_decode($request->session()->get('auth'));

        $this->data["kapal"] = $this->data["namaKapal"] = $auth->namaKapal;
        $this->data["noLaporan"] = $input["noLaporan"];
        $this->data["tipe"] = "MONTH";
        $this->data["textType"] = "BULAN";
        $tahunReport = $input["tahunReport"];

        PDF::SetTitle('LAPORAN PENERIMAAN DAN PEMAKAIAN MINYAK PELUMAS PER BULAN');
        PDF::AddPage();
        PDF::setPageOrientation("L");

        PDF::setFooterCallback(function ($pdf) {
            $pdf->SetY(-15);
            $pdf->SetFont('helvetica', 'I', 8);
            $pdf->Cell(0, 10, 'Halaman ' . $pdf->getAliasNumPage() . '/' . $pdf->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
        });

        $this->data["i"] = 1;
        $this->data["data"] = $this->baseService->getDataReport($tahunReport, $this->data["tipe"]);

        $this->data["approver"] = $this->users->getNahkodaProfile($auth->kapalId, $auth->sysParams->JABATANNAHKODA);
        $this->data["requester"] = $this->users->getNahkodaProfile($auth->kapalId, $auth->sysParams->JABATANKKM);
        // return view("modules.pelumas.pelumasbulan_pdf", $this->data);
        $view = \View::make("modules.pelumas.pelumasbulan_pdf", $this->data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('laporan-pelumas-bulan.pdf');
    }
}
